LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
use ieee.math_real.all;
use work.bstypes.all;
 
ENTITY tb_BubbleSort IS
END tb_BubbleSort;
 
ARCHITECTURE behavior OF tb_BubbleSort IS 
    COMPONENT Bubblesort
    Port ( di    : in  BSData_Typ;
           do    : out BSData_Typ;
           start : in  std_logic;
           done  : out std_logic;
           clk   : in  std_logic);
    END COMPONENT;

   --Inputs
   signal di    : BSData_Typ := (1,0,2,3,4,5,6,7,8,9);
--   signal di    : BSData_Typ := (9,6,1,8,7,2,4,5,3,0);
   signal start : std_logic := '0';
   signal clk   : std_logic := '0';
 	--Outputs
   signal do    : BSData_Typ;
   signal done  : std_logic;
   
BEGIN
	-- Instantiate the Unit Under Test (UUT)
   uut: Bubblesort PORT MAP (
          di    => di,
          do    => do,
          start => start,
          done  => done,
          clk   => clk
        );

   clk <= not clk after 5ns;

   -- Stimulus process
   stim_proc: process
    variable rand  : real;
    variable seed1 : positive := 234;
    variable seed2 : positive := 567;
   begin		
      wait for 100 ns;	
      loop
         wait until rising_edge(clk);
         start <= '1';
         wait until rising_edge(clk);
         start <= '0';
         wait until done='1';
         for i in 0 to 8 loop
            assert do(i)<=do(i+1) report "Falsche Reihenfolge!" severity failure;
         end loop;
         for i in 0 to 9 loop
            UNIFORM(seed1, seed2, rand);
            di(i) <= integer(TRUNC(rand*127.999));
         end loop;
      end loop;
   end process;

END;
